﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Sample
{
    public partial class Form1 : Form
    {
        //------------------------------------------
        // MODE
        public const byte MAC_MD_UNUSED = 0;
        public const byte MAC_MD_RW_WIN_DATA = 1;
        public const byte MAC_MD_GET_SIZE = 2;

        //------------------------------------------
        // DATA TYPE
        public const byte MAC_DT_BYTE = 0;
        public const byte MAC_DT_WORD = 1;
        public const byte MAC_DT_DWORD = 2;
        public const byte MAC_DT_CHAR = 3;
        public const byte MAC_DT_SHORT = 4;
        public const byte MAC_DT_LONG = 5;
        public const byte MAC_DT_FLOAT = 6;
        public const byte MAC_DT_DOUBLE = 7;
        public const byte MAC_DT_STR_W = 8;
        public const byte MAC_DT_STR_M = 9;
        public const byte MAC_DT_BIT = 10;


        public Form1()
        {
            InitializeComponent();

            Load_Prop();    // プロパティをロード
            Disp_Prop();    // 結果表示
        }



        private void button1_Click(object sender, EventArgs e)
        {
            Save_Prop();    // プロパティを設定
            Disp_Prop();    // 結果表示
        }



        ///////////////////////////////////////////
        // Get Property
        private void Load_Prop()
        {
            // Property Load
            txtMemName.Text = axINpMacWin1.MemoryName;
            cmbMode.SelectedIndex = axINpMacWin1.Mode;
            txtOffset.Text = axINpMacWin1.Offset.ToString();
            cmbBitOffset.SelectedIndex = axINpMacWin1.BitOffset;
            cmbType.SelectedIndex = axINpMacWin1.Type;
            txtValue.Text = "";
            txtStatus.Text = axINpMacWin1.Status.ToString();
            if(axINpMacWin1.CreateMemory>0) chkCreateMem.Checked = true;
            else                            chkCreateMem.Checked = false;
        }

        ///////////////////////////////////////////
        // Set Property
        private void Save_Prop()
        {
            // Property Set
            axINpMacWin1.MemoryName = txtMemName.Text;
            axINpMacWin1.Mode = (byte)cmbMode.SelectedIndex;
            axINpMacWin1.Offset = Convert.ToInt32(txtOffset.Text);
            axINpMacWin1.BitOffset = (byte)cmbBitOffset.SelectedIndex;
            axINpMacWin1.Type = (byte)cmbType.SelectedIndex;
            if (chkCreateMem.Checked)   axINpMacWin1.CreateMemory = 1;
            else                        axINpMacWin1.CreateMemory = 0;

            // ! Value = "" then Read Only.
            if (txtValue.Text.Length > 0) {
                axINpMacWin1.Value = (object)txtValue.Text;
            }
        }

        ///////////////////////////////////////////
        // Now Property
        private void Disp_Prop()
        {
            object vValue;

            txtMemName2.Text = axINpMacWin1.MemoryName;
            txtMode2.Text = cmbMode.Items[axINpMacWin1.Mode].ToString();
            txtOffset2.Text = axINpMacWin1.Offset.ToString();
            txtBitOffset2.Text = cmbBitOffset.Items[axINpMacWin1.BitOffset].ToString();
            txtType2.Text = cmbType.Items[axINpMacWin1.Type].ToString();
            
            // Value Set
            vValue = axINpMacWin1.Value;
            switch (axINpMacWin1.Mode)
            {
            case MAC_MD_UNUSED:         // MODE: Unused
                txtValue2.Text = vValue.ToString();
                break;

            case MAC_MD_RW_WIN_DATA:    // MODE: Memory R/W
                switch (axINpMacWin1.Type)
                {
                case MAC_DT_FLOAT:              // Single Type
                    txtValue2.Text = string.Format("{0}",vValue);
                    break;
                case MAC_DT_DOUBLE:             // Double Type
                    txtValue2.Text = string.Format("{0}",vValue);
                    break;
                case MAC_DT_STR_W:
                case MAC_DT_STR_M:              // String Type  
                    txtValue2.Text = string.Format("\"{0}\"",vValue);
                    break;
                default:                        // Other Type
                    txtValue2.Text = string.Format("{0}({0:X8}h)", vValue);
                    break;
                }
                break;

            case MAC_MD_GET_SIZE:       // MODE: Get Size
                txtValue2.Text = string.Format("{0}({0:X8}h)", vValue);
                break;                
            }
            
            // Status Set
            txtStatus2.Text = string.Format("{0}({0:X8}h)", axINpMacWin1.Status);
        }

        private void axINpMacWin1_OnError(object sender, AxINpMacWinLib._DINpMacWinEvents_OnErrorEvent e)
        {
            MessageBox.Show(string.Format("Error: 0x{0:X8} ({0})", e.errCode), "Error!!!", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
        

    }


}
